      function bspfit(n,cf,x0,dx,xlog,ylog,xx)
      implicit doubleprecision (a-h,o-z)
c give function value and partial derivatives
c
c            ix+1
c            ___ 
c  f(x,y) =  >    c(i)*bspl(i,x1)
c            --- 
c           i=ix-2
c
c    where ix=int((x-x0)/dx),
c          x1= (x-x0)/dx + 1
c
c fitting parameters
      dimension cf(n)
      logical xlog,ylog, newcoef
c input
c    x: coordinate of the point
c working area
      dimension c0(4,4), cc0(4)
      data c0/-1.d0, 3.d0,-3.d0, 1.d0, 3.d0,-6.d0, 0.d0, 4.d0,
     &        -3.d0, 3.d0, 3.d0, 1.d0, 1.d0, 0.d0, 0.d0, 0.d0/
      save c0, cf1, cc0, ix0
      data ix0/-1000000000/
       if (xlog) then 
         x=log10(xx)
      else
         x=xx
      end if
       x1 = (x-x0)/dx + 1.0d0
      ix = int(x1+100000.0) -100000
       newcoef = (ix.ne.ix0).or.(cf1.ne.cf(1))
       ibgn = max(1,ix-1)
      iend = min(n,ix+2)
       s = x1 - real(ix)
      if(newcoef) then
         do k=4,1,-1
            cc0(k) = 0.
            do 3 i=ibgn, iend
               j = i - ix + 2
               cc0(k) = cc0(k) + cf(i)*c0(k,j)
 3          continue
         enddo
         cf1 = cf(1)
         ix0 = ix
      end if
       b = cc0(4) + s*(cc0(3)+s*(cc0(2)+s*cc0(1)))
       if (ylog) then
         bspfit  = exp(b*log(10.d0))
      else
         bspfit  = b
      end if
c
      return
      end
c
      function bsfitd(n,cf,x0,dx,xlog,ylog,xx)
      implicit doubleprecision (a-h,o-z)
c give function value and partial derivatives
c
c            ix+1
c            ___ 
c  f(x,y) =  >    c(i)*bspl(i,x1)
c            --- 
c           i=ix-2
c
c    where ix=int((x-x0)/dx),
c          x1= (x-x0)/dx + 1
c
c fitting parameters
      dimension cf(n)
      logical xlog,ylog, newcoef
c input
c    x: coordinate of the point
c     working area
      dimension cc0(4), cc1(3)
      dimension c0(4,4), c1(3,4)
      data c0/-1.d0, 3.d0,-3.d0, 1.d0, 3.d0,-6.d0, 0.d0, 4.d0,
     &        -3.d0, 3.d0, 3.d0, 1.d0, 1.d0, 0.d0, 0.d0, 0.d0/
       data c1/-3.d0, 6.d0,-3.d0, 9.d0,-12.d0, 0.d0, 
     &        -9.d0, 6.d0, 3.d0, 3.d0, 0.d0, 0.d0/
      save c0, c1, cf1, cc0, cc1, ix0
      data ix0/-1000000000/
       if (xlog) then 
         x=log10(xx)
      else
         x=xx
      end if
      x1 = (x-x0)/dx + 1.0d0
      ix = int(x1+100000.0) -100000
       newcoef = (ix.ne.ix0).or.(cf1.ne.cf(1))
       ibgn = max(1,ix-1)
      iend = min(n,ix+2)
       s = x1 - real(ix)
      if(newcoef) then
         do k=1,3
            cc1(k) = 0.
            do i=ibgn, iend
               j = i - ix + 2
               cc1(k) = cc1(k) + cf(i)*c1(k,j)
            enddo
         enddo
         cf1 = cf(1)
         ix0 = ix
      end if
      db = (cc1(3)+s*(cc1(2)+s*cc1(1)))
       bsfitd  = db/dx
      if (ylog) then
         if(newcoef) then
            do k=4,1,-1
               cc0(k) = 0.
               do i=ibgn, iend
                  j = i - ix + 2
                  cc0(k) = cc0(k) + cf(i)*c0(k,j)
               enddo
            enddo
         end if
          b = cc0(4) + s*(cc0(3)+s*(cc0(2)+s*cc0(1)))
         bsfitd  = log(10.d0)*bsfitd*exp(b*log(10.d0))
      end if
      if (xlog) then
         bsfitd  = bsfitd/xx/log(10.d0)
      end if
      return
      end


      subroutine bsfitvdv(n,cf,x0,dx,xlog,ylog,xx, v, dv)
      implicit real*8 (a-h,o-z)
c give function value and partial derivatives
c
c            ix+1
c            ___ 
c  f(x,y) =  >    c(i)*bspl(i,x1)
c            --- 
c           i=ix-2
c
c    where ix=int((x-x0)/dx),
c          x1= (x-x0)/dx + 1
c
c fitting parameters
      dimension cf(n)
      logical xlog,ylog, newcoef
c input
c    x: coordinate of the point

      dimension cc0(4), cc1(3)
      dimension c0(4,4), c1(3,4)
      data c0/-1.d0, 3.d0,-3.d0, 1.d0, 3.d0,-6.d0, 0.d0, 4.d0,
     &        -3.d0, 3.d0, 3.d0, 1.d0, 1.d0, 0.d0, 0.d0, 0.d0/

      data c1/-3.d0, 6.d0,-3.d0, 9.d0,-12.d0, 0.d0, 
     &        -9.d0, 6.d0, 3.d0, 3.d0, 0.d0, 0.d0/
      save c0, c1, cf1, cc0, cc1, ix0
      data ix0/-1000000000/

      if (xlog) then 
         x=log10(xx)
      else
         x=xx
      end if
      x1 = (x-x0)/dx + 1.0d0
      ix = int(x1+100000.0) -100000

      newcoef = (ix.ne.ix0).or.(cf1.ne.cf(1))

      ibgn = max(1,ix-1)
      iend = min(n,ix+2)

      s = x1 - real(ix)
      if(newcoef) then
         do k=4,1,-1
            cc0(k) = 0.
            do i=ibgn, iend
               j = i - ix + 2
               cc0(k) = cc0(k) + cf(i)*c0(k,j)
            enddo
         enddo

         do k=1,3
            cc1(k) = 0.
            do i=ibgn, iend
               j = i - ix + 2
               cc1(k) = cc1(k) + cf(i)*c1(k,j)
            enddo
         enddo
         cf1 = cf(1)
         ix0 = ix
      end if

      v  = cc0(4) + s*(cc0(3)+s*(cc0(2)+s*cc0(1)))
      db = (cc1(3)+s*(cc1(2)+s*cc1(1)))/dx

      if (ylog) then
         v   = exp(b*log(10.d0))
         dv  = dv*exp(b*log(10.d0))
      end if
      if (xlog) then
         dv  = dv/xx
      end if

      return
      end
